#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six29004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six29004xi = {
                1:'-1037x2563y-872z',
                2:'-1056x1561y-2203z',
                3:'-1123x1486y-2221z',
                4:'-1127x2498y-947z',
                5:'-1166x2497y-899z',
                6:'-1185x1408y-2240z',
                7:'-1242x1328y-2258z',
                8:'-1252x2427y-974z',
                9:'-1291x2425y-927z',
                10:'-1293x1245y-2276z',
                11:'-1340x1161y-2294z',
                12:'-1373x2349y-1002z',
                13:'-1380x1075y-2312z',
                14:'-1411x2346y-954z',
                15:'-1416x988y-2329z',
                16:'-1446x900y-2346z',
                17:'-144x1141y-2661z',
                18:'-1459x48y-2505z',
                19:'-1470x812y-2363z',
                20:'-1480x127y-2490z',
                21:'-1488x2266y-1029z',
                22:'-1489x723y-2380z',
                23:'-1496x207y-2475z',
                24:'-1503x635y-2396z',
                25:'-1507x290y-2460z',
                26:'-1512x547y-2413z',
                27:'-1514x375y-2444z',
                28:'-1515x460y-2429z',
                29:'-1527x2261y-982z',
                30:'-1598x2176y-1056z',
                31:'-1637x2170y-1009z',
                32:'-1703x2081y-1083z',
                33:'-1742x2073y-1036z',
                34:'-1803x1981y-1110z',
                35:'-1830x2249y-8z',
                36:'-1841x1972y-1063z',
                37:'-1896x1876y-1136z',
                38:'-1933x1865y-1090z',
                39:'-1945x2150y-37z',
                40:'-1983x1767y-1163z',
                41:'-199x1106y-2673z',
                42:'-2020x1754y-1117z',
                43:'-2054x2045y-66z',
                44:'-2063x1653y-1189z',
                45:'-2100x1639y-1144z',
                46:'-2137x1536y-1216z',
                47:'-2158x1934y-95z',
                48:'-2174x1520y-1170z',
                49:'-2205x1415y-1242z',
                50:'-2240x1398y-1197z',
                51:'-2255x1818y-124z',
                52:'-2265x1292y-1268z',
                53:'-2300x1273y-1223z',
                54:'-2318x1165y-1294z',
                55:'-2346x1696y-153z',
                56:'-2364x1037y-1320z',
                57:'-2402x907y-1346z',
                58:'-2430x1570y-182z',
                59:'-2433x1185y-1292z',
                60:'-2433x776y-1371z',
                61:'-2457x644y-1397z',
                62:'-2474x512y-1422z',
                63:'-2480x116y-1497z',
                64:'-2483x380y-1447z',
                65:'-2485x248y-1473z',
                66:'-2508x1440y-211z',
                67:'-251x1068y-2684z',
                68:'-256x2060y-2024z',
                69:'-2577x1306y-240z',
                70:'-2640x1168y-268z',
                71:'-2695x1027y-297z',
                72:'-2742x884y-326z',
                73:'-2781x738y-355z',
                74:'-2812x591y-384z',
                75:'-2836x442y-412z',
                76:'-2851x293y-441z',
                77:'-2858x143y-470z',
                78:'-299x1027y-2695z',
                79:'-306x2775y-781z',
                80:'-343x985y-2705z',
                81:'-360x2023y-2045z',
                82:'-384x940y-2716z',
                83:'-398x12y-2872z',
                84:'-421x894y-2726z',
                85:'-426x35y-2868z',
                86:'-450x2748y-809z',
                87:'-452x61y-2863z',
                88:'-454x847y-2735z',
                89:'-460x1982y-2065z',
                90:'-476x90y-2859z',
                91:'-484x798y-2745z',
                92:'-487x2755y-761z',
                93:'-498x122y-2854z',
                94:'-510x749y-2754z',
                95:'-518x156y-2848z',
                96:'-531x699y-2763z',
                97:'-536x192y-2843z',
                98:'-549x650y-2772z',
                99:'-552x231y-2837z',
                100:'-558x1935y-2086z',
                101:'-564x272y-2831z',
                102:'-564x600y-2780z',
                103:'-574x315y-2824z',
                104:'-574x550y-2788z',
                105:'-581x359y-2818z',
                106:'-581x501y-2796z',
                107:'-584x405y-2811z',
                108:'-584x453y-2804z',
                109:'-591x2712y-837z',
                110:'-629x2718y-788z',
                111:'-651x1883y-2106z',
                112:'-730x2669y-864z',
                113:'-741x1827y-2126z',
                114:'-768x2674y-816z',
                115:'-827x1766y-2145z',
                116:'-866x2619y-892z',
                117:'-86x1173y-2650z',
                118:'-904x2622y-844z',
                119:'-908x1702y-2165z',
                120:'-985x1633y-2184z',
                121:'-999x2562y-919z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire2900six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2900SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six2900x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six2900x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE2900SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
